#include "xslt.h"
const char *xslt_svg2lowlevel = 
"<?xml version=\"1.0\"?>\n"
"<xsl:stylesheet	xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" \n"
"				xmlns:inkscape=\"http://www.inkscape.org/namespaces/inkscape\"\n"
"				xmlns:svg=\"http://www.w3.org/2000/svg\"\n"
"				xmlns:swft=\"http://subsignal.org/swfml/swft\"\n"
"				extension-element-prefixes=\"swft\"\n"
"				version='1.0'>\n"
"\n"
"<xsl:output method=\"xml\" indent=\"yes\"/>\n"
"\n"
"<xsl:template match=\"svg:svg\">\n"
"	<swf version=\"7\" compressed=\"1\">\n"
"		<Header framerate=\"1\" frames=\"1\">\n"
"			<size>\n"
"				<Rectangle left=\"0\" right=\"6400\" top=\"0\" bottom=\"4800\"/>\n"
"			</size>\n"
"			<tags>\n"
"				<SetBackgroundColor>\n"
"					<color>\n"
"						<Color red=\"100\" green=\"150\" blue=\"200\"/>\n"
"					</color>\n"
"				</SetBackgroundColor>\n"
"				<xsl:apply-templates mode=\"svg\">\n"
"					<xsl:with-param name=\"parentx\">100</xsl:with-param>\n"
"					<xsl:with-param name=\"parenty\">100</xsl:with-param>\n"
"				</xsl:apply-templates>\n"
"				<ShowFrame/>\n"
"				<End/>\n"
"			</tags>\n"
"		</Header>\n"
"	</swf>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"svg:g|svg:path|svg:rect\" mode=\"svg\">\n"
"	<xsl:param name=\"parentx\">0</xsl:param>\n"
"	<xsl:param name=\"parenty\">0</xsl:param>\n"
"	\n"
"	<xsl:variable name=\"id\"><xsl:value-of select=\"swft:map-id(@id)\"/></xsl:variable> \n"
"	<xsl:variable name=\"xofs\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@inkscape:px\">\n"
"				<xsl:value-of select=\"@inkscape:px\"/>\n"
"			</xsl:when>\n"
"			<xsl:otherwise>0</xsl:otherwise> <!-- \"none\" for special treatment? -->\n"
"		</xsl:choose>\n"
"	</xsl:variable> \n"
"	<xsl:variable name=\"yofs\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@inkscape:py\">\n"
"				<xsl:value-of select=\"@inkscape:py\"/>\n"
"			</xsl:when>\n"
"			<xsl:otherwise>0</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable> \n"
"	<xsl:variable name=\"name\" select=\"@id\"/>\n"
"	<xsl:variable name=\"class\" select=\"@class\"/>\n"
"\n"
"	<xsl:apply-templates select=\".\" mode=\"svg-inner\">\n"
"		<xsl:with-param name=\"id\" select=\"$id\"/>\n"
"		<xsl:with-param name=\"name\" select=\"$name\"/>\n"
"		<xsl:with-param name=\"xofs\" select=\"$xofs\"/>\n"
"		<xsl:with-param name=\"yofs\" select=\"$yofs\"/>\n"
"		<xsl:with-param name=\"parentx\" select=\"$parentx\"/>\n"
"		<xsl:with-param name=\"parenty\" select=\"$parenty\"/>\n"
"	</xsl:apply-templates>\n"
"	<Export>\n"
"		<symbols>\n"
"		  <Symbol objectID=\"{$id}\" name=\"{$name}\"/>\n"
"		</symbols>\n"
"	</Export>\n"
"	\n"
"	<xsl:if test=\"string-length($class) > 0\">\n"
"		<xsl:call-template name=\"register-class\">\n"
"			<xsl:with-param name=\"class\" select=\"$class\"/>\n"
"			<xsl:with-param name=\"linkage-id\" select=\"$name\"/>\n"
"		</xsl:call-template>\n"
"	</xsl:if>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"svg:g\" mode=\"svg-inner\">\n"
"	<xsl:param name=\"id\"/>\n"
"	<xsl:param name=\"name\"/>\n"
"	<xsl:param name=\"xofs\"/>\n"
"	<xsl:param name=\"yofs\"/>\n"
"	<xsl:param name=\"parentx\"/>\n"
"	<xsl:param name=\"parenty\"/>\n"
"	<xsl:variable name=\"subid\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"\n"
"	<DefineSprite objectID=\"{$id}\" frames=\"1\">\n"
"		<tags>\n"
"			<xsl:apply-templates mode=\"svg\">\n"
"				<xsl:with-param name=\"parentx\" select=\"-$xofs\"/>\n"
"				<xsl:with-param name=\"parenty\" select=\"-$yofs\"/>\n"
"			</xsl:apply-templates>\n"
"			<ShowFrame/>\n"
"			<End/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<PlaceObject2 replace=\"0\" depth=\"{swft:next-depth()}\" name=\"{$name}\" objectID=\"{$id}\">\n"
"		<transform>\n"
"			<xsl:choose>\n"
"				<xsl:when test=\"@transform\">\n"
"					<xsl:copy-of select=\"swft:transform(@transform,($parentx+$xofs),($parenty+$yofs))\"/>\n"
"				</xsl:when>\n"
"				<xsl:otherwise>\n"
"					<Transform transX=\"{($parentx+$xofs)*20}\" transY=\"{($parenty+$yofs)*20}\"/>\n"
"				</xsl:otherwise>\n"
"			</xsl:choose>\n"
"		</transform>\n"
"	</PlaceObject2>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"svg:path\" mode=\"svg-inner\">\n"
"	<xsl:param name=\"id\"/>\n"
"	<xsl:param name=\"parentx\">0</xsl:param>\n"
"	<xsl:param name=\"parenty\">0</xsl:param>\n"
"	<xsl:param name=\"xofs\"/>\n"
"	<xsl:param name=\"yofs\"/>\n"
"	<xsl:variable name=\"shapeid\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"\n"
"	<xsl:variable name=\"bounds\" select=\"swft:bounds(@d)\"/>\n"
"	<xsl:variable name=\"xo\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"$xofs = 'none'\">\n"
"				<xsl:value-of select=\"number($bounds/Rectangle/@left) div 20\"/>\n"
"			</xsl:when>\n"
"			<xsl:otherwise>\n"
"				<xsl:value-of select=\"$xofs\"/>\n"
"			</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"yo\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"$yofs = 'none'\">\n"
"				<xsl:value-of select=\"number($bounds/Rectangle/@top) div 20\"/>\n"
"			</xsl:when>\n"
"			<xsl:otherwise>\n"
"				<xsl:value-of select=\"$yofs\"/>\n"
"			</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"\n"
"	<DefineShape3 objectID=\"{$shapeid}\">\n"
"		<bounds>\n"
"			<xsl:copy-of select=\"swft:bounds(@d,-1 * $xo,-1 * $yo)\"/>\n"
"		</bounds>\n"
"		<styles>\n"
"			<StyleList>\n"
"				<xsl:copy-of select=\"swft:css(@style)/tmp/*\"/>\n"
"			</StyleList>\n"
"		</styles>\n"
"		<shapes>\n"
"			<Shape>\n"
"				<xsl:apply-templates mode=\"shape\" select=\"swft:path(@d,(-$xo),(-$yo))/tmp/Shape/*\"/>\n"
"			</Shape>\n"
"		</shapes>\n"
"	</DefineShape3>\n"
"	<DefineSprite objectID=\"{$id}\" frames=\"1\">\n"
"		<tags>\n"
"			<PlaceObject2 replace=\"0\" depth=\"{swft:next-depth()}\" objectID=\"{$shapeid}\">\n"
"				<transform>\n"
"					<Transform transX=\"0\" transY=\"0\"/>\n"
"				</transform>\n"
"			</PlaceObject2>\n"
"			<ShowFrame/>\n"
"			<End/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<PlaceObject2 replace=\"0\" depth=\"{swft:next-depth()}\" name=\"{$name}\" objectID=\"{$id}\">\n"
"		<transform>\n"
"			<xsl:choose>\n"
"				<xsl:when test=\"@transform\">\n"
"					<xsl:copy-of select=\"swft:transform(@transform,($xo + $parentx),($yo + $parenty))\"/>\n"
"				</xsl:when>\n"
"				<xsl:otherwise>\n"
"					<Transform transX=\"{($parentx + $xo)*20}\" transY=\"{($parenty + $yo)*20}\"/>\n"
"				</xsl:otherwise>\n"
"			</xsl:choose>\n"
"		</transform>\n"
"	</PlaceObject2>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"svg:rect\" mode=\"svg-inner\">\n"
"	<xsl:param name=\"id\"/>\n"
"	<xsl:param name=\"name\"/>\n"
"	<xsl:param name=\"xofs\"/>\n"
"	<xsl:param name=\"yofs\"/>\n"
"	<xsl:param name=\"parentx\">0</xsl:param>\n"
"	<xsl:param name=\"parenty\">0</xsl:param>\n"
"	<xsl:variable name=\"shapeid\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"\n"
"	<xsl:variable name=\"xo\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"$xofs = 'none'\">\n"
"				<xsl:value-of select=\"@x\"/>\n"
"			</xsl:when>\n"
"			<xsl:otherwise>\n"
"				<xsl:value-of select=\"$xofs\"/>\n"
"			</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"yo\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"$yofs = 'none'\">\n"
"				<xsl:value-of select=\"@y\"/>\n"
"			</xsl:when>\n"
"			<xsl:otherwise>\n"
"				<xsl:value-of select=\"$yofs\"/>\n"
"			</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"\n"
"	<DefineShape3 objectID=\"{$shapeid}\">\n"
"		<bounds>\n"
"			<Rectangle left=\"{@x}\" right=\"{(@x+@width)*20}\" top=\"{@y}\" bottom=\"{(@y+@height)*20}\"/>\n"
"		</bounds>\n"
"		<styles>\n"
"			<StyleList>\n"
"				<xsl:copy-of select=\"swft:css(@style)/tmp/*\"/>\n"
"			</StyleList>\n"
"		</styles>\n"
"		<shapes>\n"
"			<Shape>\n"
"				<edges>\n"
"					<ShapeSetup x=\"{(@x+@width)*20}\" y=\"{(@y+@height)*20}\" fillStyle0=\"1\" lineStyle=\"1\"/>\n"
"					<LineTo x=\"-{(@width)*20}\" y=\"0\"/>\n"
"					<LineTo x=\"0\" y=\"-{(@height)*20}\"/>\n"
"					<LineTo x=\"{(@width)*20}\" y=\"0\"/>\n"
"					<LineTo x=\"0\" y=\"{(@height)*20}\"/>\n"
"					<ShapeSetup/>\n"
"				</edges>\n"
"			</Shape>\n"
"		</shapes>\n"
"	</DefineShape3>\n"
"	<DefineSprite objectID=\"{$id}\" frames=\"1\">\n"
"		<tags>\n"
"			<PlaceObject2 replace=\"0\" depth=\"{swft:next-depth()}\" objectID=\"{$shapeid}\">\n"
"				<transform>\n"
"					<Transform transX=\"{-$xo*20}\" transY=\"{-$yo*20}\"/>\n"
"				</transform>\n"
"			</PlaceObject2>\n"
"			<ShowFrame/>\n"
"			<End/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<PlaceObject2 replace=\"0\" depth=\"{swft:next-depth()}\" name=\"{$name}\" objectID=\"{$id}\">\n"
"		<transform>\n"
"			<xsl:choose>\n"
"				<xsl:when test=\"@transform\">\n"
"					<xsl:copy-of select=\"swft:transform(@transform,($xo + $parentx),($yo + $parenty))\"/>\n"
"				</xsl:when>\n"
"				<xsl:otherwise>\n"
"					<Transform transX=\"{($parentx + $xo)*20}\" transY=\"{($parenty + $yo)*20}\"/>\n"
"				</xsl:otherwise>\n"
"			</xsl:choose>\n"
"		</transform>\n"
"	</PlaceObject2>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*|@*|text()\" mode=\"svg\" priority=\"-1\"/>\n"
"\n"
"<!-- works only if the id is exported! -->\n"
"<xsl:template name=\"register-class\">\n"
"	<xsl:param name=\"class\"/>\n"
"	<xsl:param name=\"linkage-id\"/>\n"
"	<xsl:variable name=\"packages\" select=\"str:tokenize($class,'.')\"/>\n"
"	<xsl:variable name=\"strofs\">3</xsl:variable>\n"
"	<xsl:variable name=\"id\" select=\"swft:next-id()\"/>\n"
"\n"
"	<DefineSprite objectID=\"{$id}\" frames=\"1\">\n"
"		<tags>\n"
"		  <End/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<Export>\n"
"		<symbols>\n"
"		  <Symbol objectID=\"{$id}\" name=\"__Packages.swfmill.registerClass.{$linkage-id}\"/>\n"
"		</symbols>\n"
"	</Export>\n"
"	<DoInitAction sprite=\"{$id}\">\n"
"		<actions>\n"
"			<Dictionary>\n"
"				<strings>\n"
"					<String value=\"Object\"/>\n"
"					<String value=\"registerClass\"/>\n"
"					<String value=\"{$linkage-id}\"/>\n"
"					<xsl:for-each select=\"$packages\">\n"
"						<String value=\"{.}\"/>\n"
"					</xsl:for-each>\n"
"				</strings>\n"
"			</Dictionary>\n"
"			\n"
"			<!-- package root -->\n"
"			<PushData>\n"
"				<items>\n"
"				  <StackDictionaryLookup index=\"{$strofs}\"/> \n"
"				</items>\n"
"			</PushData>\n"
"			<GetVariable/>\n"
"			\n"
"			<!-- packages -->\n"
"			<xsl:for-each select=\"$packages[position()>1]\">\n"
"				<PushData>\n"
"					<items>\n"
"					  <StackDictionaryLookup index=\"{$strofs + position()}\"/>\n"
"					</items>\n"
"				</PushData>\n"
"				<GetMember/>\n"
"			</xsl:for-each>\n"
"			\n"
"			<!-- linkage id, 2 (arguments), Object-->\n"
"			<PushData>\n"
"				<items>\n"
"				  <StackDictionaryLookup index=\"2\"/>\n"
"				  <StackInteger value=\"2\"/>\n"
"				  <StackDictionaryLookup index=\"0\"/>\n"
"				</items>\n"
"			</PushData>\n"
"			<GetVariable/>\n"
"			<!-- registerClass -->\n"
"			<PushData>\n"
"				<items>\n"
"				  <StackDictionaryLookup index=\"1\"/>\n"
"				</items>\n"
"			</PushData>\n"
"			<CallMethod/>\n"
"			<Pop/>\n"
"			<EndAction/>\n"
"		</actions>\n"
"	</DoInitAction>\n"
"	\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
;
